************************************************************************
*PROCEDURE CGICount
******************
***  Modified: 03/28/96
***  Function: Summarizes CGI hits on a site based on the first
***            parameter.
***    Assume: First Parameter is the Application name (wwDemo,Windance etc)
***            Parameters are separated by ~ chars
***      Pass: lcFile      -   Logfile created by Web Connection
***            lcParmChar  -   Parameter separator
***            lnGroupParm -   Which parameter to group on
***    Return: Cursor TCGISummary filled with summary
*************************************************************************
LPARAMETER lcFile, lcParmChar, lnGroupParameter

lcFile=IIF(type("lcFile")="C",lcFile,GETFILE('DBF', 'Select Log File:', 'Open',0))

lcParmChar=IIF(type("lcParmChar")="C",lcParmChar,"~")
lnGroupParm=IIF(type("lnGroupParm")="N",lnGroupParm,1)

IF lnGroupParm=1
   *** First parameter isn't bracketed with ~
   *** So we'll add it for extract to work
   *** generically
   lcPadChar=lcParmChar
ELSE
   lcPadChar=""
ENDIF

#INCLUDE WCONNECT.H
#IF SHAREWARE
   DO WCONNECT.APP
#ELSE   
  SET PROCEDURE TO WWUTILS ADDITIVE
#ENDIF

SELECT TIME ,;
       PADR(lower( EXTRACT(lcPadChar+Request,lcParmChar,lcParmChar," ")),20)  AS Client, ;
       duration ;
  FROM (lcFile)  ;
  INTO CURSOR TQuery

*** Must run separate query in order to group on Calc field
SELECT MIN(TIME) AS FROM, MAX(Time) AS TO,;
       Client,;
       SUM(1) AS Hits,;
       SUM(duration) As TotalDuration, ;
       AVG(duration) as AvergeDuration ;
   FROM Tquery ;
   GROUP BY CLient ;
   ORDER BY TotalDuration DESC ;
   INTO CURSOR TCGISummary
     
USE IN Tquery

BROWSE
RETURN
