************************************************************************
*PROCEDURE TableWizard
***********************
***  Modified: 03/19/96
***  Function: Creates HTML class code for an HTML/<PRE> tag list
***            formatted table.
***      Pass: lcOutputFile  -  Output program file
*************************************************************************
PARAMETER lcOutputFile, pcOutputHTML

LOCAL loHTML

IF EMPTY(ALIAS())
   lcDataFile=GETFILE('DBF', 'Datafile to Code for:', 'Open',0) && 0 = Open/Cancel 1=Open/Cancel/New    
   IF EMPTY(lcDataFile)
      wait window nowait "No input file selected. Make sure you open a table first..."
      RETURN
   ENDIF
ENDIF

IF EMPTY(lcOutputFile)
  lcOutputFile = PUTFILE('Save program to:', "TEMP.PRG", 'PRG')
  IF EMPTY(lcOutputFile)
     RETURN
  ENDIF
ENDIF

*** Output File name
pcOutputHTML=IIF(type("lcOutputHTML")="C",lcOutputHTML,;
                 STRTRAN(UPPER(lcOutputfile),".PRG",".HTM") ) 


#INCLUDE WCONNECT.H
#IF SHAREWARE
   DO WCONNECT.APP
#ELSE   
   SET PROCEDURE TO HTML ADDITIVE
#ENDIF

CLEAR

lcRetval=TableWiz()

loHTML=CREATE("wwHTML",lcOutputFile)

loHTML.Send(lcRetVal)

RELEASE loHTML

MODI COMM (lcOutputFile)
RETURN


************************************************************************
* wwHTML :: HTMLTableWizard
*********************************
***  Function: Displays the currently selected table.
***            300 recs and less display HTML 2.0 table,
***            otherwise PRE formatted list is displayed.
***      Pass: lvHeader   -    1D Array: Column Headers for each col
***                            Pass by reference!!!
***             lcTitle   -    Table Header (only works with Tables)
***        llSumNumbers   -    Auto sum all numeric fields in table
***    Return: .T. or .F.
************************************************************************
FUNCTION TableWiz
LPARAMETER lvheader, lctitle, llsumnumbers, llNoOutput
LOCAL lcheader, x, latotals, lcOutput, lnSizeLoc, lnSize

llCreateHTMLClass=.T.
lcClassName="loHTML"
lcPageHeader=""
lcBackImg=''

llSumNumbers=.T.

IF EMPTY(ALIAS())
   RETURN .F.
ENDIF

loHTML=CREATE("wwHTML","NOFILE")

lcOutput=""
IF llCreateHTMLClass
   lcOutput='*** Required files by HTML Class'+CR+;
            '#INCLUDE WCONNECT.H'+CR+;
            '#IF SHAREWARE'+CR+;
            '  DO Wconnect.app'+CR+;
            '#ELSE'+CR+;
            '  SET PROCEDURE TO HTML ADDITIVE'+CR+;
            '  SET PROCEDURE TO WWUTILS ADDITIVE'+CR+;
            '#ENDIF'+CR+CR+;            
            lcClassName+'=CREATE("wwHTML","'+pcOutputHTML+'")'+CR+CR
ENDIF

lnfields=AFIELDS(lafields)
lnreccount=RECCOUNT()

lcOutput=lcOutput+lcClassName+'.HTMLHeader("'+lcPageHeader+'","'+lcPageHeader+'","'+lcBackImg+'")'+CR+CR


*** Keep track of numeric totals
IF llsumnumbers
   DIMENSION latotals[1,lnFields]
   latotals=0
ENDIF

lctitle=IIF(TYPE("lcTitle")="C",lctitle,"")


lcOutput=lcOutput+[*** In production use: loCGI.IsNetScape() AND reccount<300]+CR+;
                  [IF .T.]+CR

*****************************************
* HTML TABLE CODE
*****************************************

   *** SHOW HTML TABLE
   
   IF !EMPTY(lctitle)
      lctitle=[<TR><TH COLSPAN=]+ALLTRIM(STR(lnfields))+[ ALIGN="CENTER"><H2>]+lctitle+[</H2></TH></TR>]
   ENDIF

   IF TYPE("lvHeader[1]")="U"
      *** No Array Passed Use Field Headers
      lcheader=""
      FOR x=1 TO lnfields
         lcheader=lcheader+[<TH>]+Proper(lafields[x,1])+[</TH>]
      ENDFOR && x=1 TO ALEN(lvType,1)

      lcheader=[<TR BGCOLOR=#FFFFCC>]+lcheader+[</TR>]
   ELSE
      *** Array of headers was passed
      lcheader=""
      FOR x=1 TO ALEN(lvheader,1)
         *** Check for header width override - Strip off for tables
         lnSizeLoc=ATC(":",lvHeader[x])
         IF lnSizeLoc>1
            lvHeader[x]=SUBSTR(lvHeader[x],1,lnSizeLoc-1)
         ENDIF

         lcheader=lcheader+[<TH>]+lvheader[x]+[</TH>]
      ENDFOR && x=1 TO ALEN(lvType,1)

      lcheader=[<TR>]+lcheader+[</TR>]
   ENDIF
   
   lcOutput=lcOutput+lcClassName + '.SendLn([<TABLE BGCOLOR=#EEEEEE CELLPADDING=4 BORDER=1 WIDTH=100%>])'+CR
   
   IF !EMPTY(lcTitle)
     lcOutput=lcOutput + lcClassName + '.SendLn([' +lctitle+ '])' +CR
   ENDIF
   
   *** No Header Passed - just add TABLE tag
   IF !EMPTY(lcheader)
      lcOutput=lcOutput+ lcClassName+'.SendLn(['+lcheader+ '])'+CR
   ENDIF

      *** Build a Field String
      lcrow=""

      FOR x=1 TO lnfields
         lcfieldname=lafields[x,1]
         lcfieldtype=lafields[x,2]

         DO CASE
         CASE lcfieldtype="C" OR lcfieldtype="M"
            lcrow=lcrow+'<TD>]+IIF(EMPTY('+lcFieldName+'),"_",ALLTRIM('+lcfieldname+'))+[</TD>'
         CASE lcfieldtype $ "NFBIY"
            lcrow=lcrow+'<TD ALIGN=RIGHT>]+ LTRIM(STR(' +lcfieldname+ ',' +LTRIM(STR(lafields[x,3]))+ ',' +LTRIM(STR(lafields[x,4]))+ '))+[</TD>'
         CASE lcfieldtype="L"
            lcrow=lcrow+'<TD ALIGN=CENTER>]+IIF(' +lcfieldname+ ',"True","False")+[</TD>'
         CASE lcfieldtype="D"
            lcrow=lcrow+'<TD ALIGN=CENTER>]+IIF(EMPTY(' +lcfieldname+ '),"_",DTOC(' +lcfieldname+ ') )+[</TD>'
         CASE lcfieldtype="T"
               lcrow=lcrow+'<TD ALIGN=CENTER>]+IIF(EMPTY(' +lcfieldname+ '),"_",TTOC(' +lcfieldname+ ') )+[</TD>'
         ENDCASE

      ENDFOR && x=1 TO lnFields

      lcrow="<TR>"+lcrow+"</TR>"


   *** Numeric Summarize Output Strings
   lcSumInit=""
   lcSumCode=""
   lcTotalRow=""

   *** Print Totals for numeric fields
   IF llsumnumbers

      FOR x=1 TO lnfields
         lcfieldname=lafields[x,1]
         lcfieldtype=lafields[x,2]

         IF lcfieldtype $ "NFBIY"
            lcSumInit=lcSumInit+"lnSum"+lcFieldName+"=0.00"+CR
            lcSumCode=lcSumCode+"   lnSum"+lcFieldName+"=lnSum"+lcFieldname+"+"+lcFieldname+CR
            lcTotalrow=lcTotalrow+'<TD ALIGN=RIGHT><b>] +STR(lnSum' +lcFieldName+ ',' +ALLTRIM(STR(lafields[x,3]+1))+ ',' +ALLTRIM(STR(lafields[x,4])) + ')+ [</b></TD>'
         ELSE
            lcTotalrow=lcTotalrow+"<TD></TD>"
         ENDIF
      ENDFOR

      lcTotalRow="<TR Border=2 BGCOLOR=#FFFFCC>"+lcTotalrow+"</TR>]"
   ENDIF


   lcOutput=lcOutput+CR+;
          '*** Initialize Summary Counters'+CR+;
          lcSumInit+CR+CR+;  
          'SELECT '+Alias()+CR+;
          'SCAN'+CR+;
          '   '+lcClassName+ '.Send(['+lcrow+']+CR)'+CR+CR+;
          '   *** Add counters for numeric fields'+CR+;
          lcSumCode+CR+;
          'ENDSCAN'+CR+CR+CR+;
          '*** Now Send the Total Row'+CR+;
          lcClassName+".SendLn(["+lcTotalRow+")"+CR


   lcOutput=lcOutput+ lcClassName + '.SendLn([</TABLE>])'

   *** End HTML Table

****************************************************************************************
* <PRE> formatted list code starts here
****************************************************************************************

lcOutput= lcOutput + CR + "ELSE"+CR+CR


   *** SHOW <PRE> </PRE> Table

   lcOutput=lcOutput+lcClassName+".SendLn([<PRE>])"+CR

   IF !EMPTY(lctitle)
      lctitle="<B>"+lctitle+"</b><p>"
   ENDIF

   IF TYPE("lvHeader[1]")="U"
      *** No Array Passed Use Field Headers
      lcheader=""
      FOR x=1 TO lnfields
         IF LEN(TRIM(lafields[x,1]))>lafields[x,3]
            lafields[x,3]=LEN(TRIM(lafields[x,1]))
         ENDIF

         *** Fix Memo Length
         IF lafields[x,2]="M"
            lafields[x,3]=20
         ENDIF
         
         *** Fix Time Data Length
         IF laFields[x,2]="T"
            laFields[x,3]=20
         ENDIF
         
         IF lafields[x,2] $ "NFBIY"
            lcheader=lcheader+PADL(lafields[x,1],lafields[x,3])+"  "
         ELSE
            lcheader=lcheader+PADR(lafields[x,1],lafields[x,3])+"  "
         ENDIF
      ENDFOR && x=1 TO ALEN(lvType,1)
   ELSE
      *** Array of headers was passed
      lcheader=""
      FOR x=1 TO ALEN(lvheader,1)
         IF LEN(TRIM(lvheader[x]))>lafields[x,3]
            lafields[x,3]=LEN(TRIM(lafields[x,1]))
         ENDIF

         *** Fix Memo Length
         IF lafields[x,2]="M"
            lafields[x,3]=20
         ENDIF
         
         *** Fix Time Data Length
         IF laFields[x,2]="T"
            laFields[x,3]=20
         ENDIF
         
         *** Check for header width override
         lnSizeLoc=ATC(":",lvHeader[x])
         IF lnSizeLoc>0
            lnSize=VAL(SUBSTR(ALLTRIM(lvHeader[x]),lnSizeLoc+1))
            lvHeader[x]=SUBSTR(lvHeader[x],1,lnSizeLoc-1)
         ELSE
            lnSize=laFields[x,3]
         ENDIF
         

         IF lafields[x,2] $ "NFBIY"
            lcheader=lcheader+PADL(lvheader[x],lnSize)+"  "
         ELSE
            lcheader=lcheader+PADR(lvheader[x],lnSize)+"  "
         ENDIF
      ENDFOR && x=1 TO ALEN(lvType,1)
   ENDIF

   lcOutput=lcOutput+lcClassName+".SendLn([<CENTER><H1>"+lctitle+"</H1></CENTER>]+CR)"+CR

   *** No Header Passed - just add TABLE tag
   IF !EMPTY(lcheader)
      lcheader="<b>"+lcheader+"</b>"
      lcOutput=lcOutput+lcClassName+".SendLn(["+lcHeader+"])"+CR
   ENDIF

  
      *** Build a Field String
      lcrow=""
      lcDivider=""

      FOR x=1 TO lnfields
         lcfieldname=lafields[x,1]
         lcfieldtype=lafields[x,2]

         IF !EMPTY(lcRow)
            lcRow=lcRow + "+"
         ENDIF

         DO CASE
         CASE lcfieldtype="C"
            lcrow=lcrow+'PADR(' +lcfieldname+ ',' +ALLTRIM(STR(lafields[x,3]))+ ' )+"  "'
         CASE lcfieldtype="M"
            lcrow=lcrow+'PADR(MLINE(' +lcfieldname+ ',1),20)+"  "'
         CASE lcfieldtype $ "NFBIY"
            lcrow=lcrow+'STR('+lcfieldname+','+ALLTRIM(STR(lafields[x,3]))+','+ALLTRIM(STR(lafields[x,4]))+')+"  "'
         CASE lcfieldtype="L"
            lcrow=lcrow+'PADR(IIF(' +lcfieldname+ ',"True","False"),'+ALLTRIM(STR(lafields[x,3])) +')+"  "'
         CASE lcfieldtype="D"
            lcrow=lcrow+'PADR(DTOC('+ lcfieldname+ '),'+ ALLTRIM(STR(lafields[x,3]))+')+"  "'
         CASE lcfieldtype="T"
            lcrow=lcrow+'PADR(TTOC('+ lcfieldname+ '),'+ ALLTRIM(STR(lafields[x,3]))+')+"  "'
         ENDCASE
         
         lcDivider=lcDivider+'PADR("-",'+ALLTRIM(STR(lafields[x,3]+2))+ ',"-")+'

      ENDFOR && x=1 TO lnFields


   *** Numeric Summarize Output Strings
   lcSumInit=""
   lcSumCode=""
   lcTotalRow=""

   *** Print Totals for numeric fields
   IF llsumnumbers

      FOR x=1 TO lnfields
         lcfieldname=lafields[x,1]
         lcfieldtype=lafields[x,2]

         IF lcfieldtype $ "NFBIY"
            lcSumInit=lcSumInit+"lnSum"+lcFieldName+"=0.00"+CR
            lcSumCode=lcSumCode+"   lnSum"+lcFieldName+"=lnSum"+lcFieldname+"+"+lcFieldname+CR
            lcTotalrow=lcTotalrow+'STR(lnSUM'+lcfieldname+','+ALLTRIM(STR(lafields[x,3]))+','+ALLTRIM(STR(lafields[x,4]))+')+"  "+'
         ELSE
            lcTotalrow=lcTotalrow+'PADR(" ",'+ALLTRIM(STR(lafields[x,3]))+ ')+"  "+'
         ENDIF
      ENDFOR


      lcTotalRow=lcDivider+"CR+[<b>]+"+lcTotalrow+"[</b>]"
   ENDIF


   lcOutput=lcOutput+CR+;
          lcClassName+'.Send('+lcDivider+'+CR)'+CR+;
          '*** Initialize Summary Counters'+CR+;
          lcSumInit+CR+CR+;  
          'SELECT '+Alias()+CR+;
          'SCAN'+CR+;
          '   '+lcClassName+ '.Send('+lcrow+'+CR)'+CR+CR+;
          '   *** Add counters for numeric fields'+CR+;
          lcSumCode+CR+;
          'ENDSCAN'+CR+CR+CR+;
          '*** Now Send the Total Row'+CR+;
          lcClassName+".SendLn("+lcTotalRow+")"+CR


   lcOutput=lcOutput+ lcClassName + '.SendLn([</PRE>])'

   *** End HTML Table

ENDIF

lcOutput=lcOutput+ CR+CR+ "ENDIF"+CR

lcOutput=lcOutput+CR+CR+lcClassName+".HTMLFooter()"+CR

RETURN lcOutPut
endproc
* ShowTable
